import { FormStore } from '../stores';
import { IMap, IStringMap } from '../types';
import { ComponentClass, FormEvent } from 'react';
import * as React from 'react';
export interface IOnSubmit {
    (form: IStringMap, ...otherArgs: any[]): any;
}
export interface IWrappedOnSubmit {
    (e: FormEvent<any>, ...otherArgs: any[]): void;
}
export interface IFormOptions<Props> {
    initialValues: IMap | ((props: Props) => IMap) | undefined;
    onSubmit: IOnSubmit;
}
export interface IFormFieldParamProps {
    __formobx: {
        store: FormStore;
        onSubmit: IWrappedOnSubmit;
    };
}
export declare function createFormField<Props>(options: IFormOptions<Props>): (WrappedComponent: ComponentClass<Props & IFormFieldParamProps> | React.StatelessComponent<Props & IFormFieldParamProps>) => ComponentClass<Props>;
