"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var stores_1 = require("../../stores");
function IsRegisteredField(superclass) {
    return (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.fields = [];
            return _this;
        }
        class_1.prototype.componentDidMount = function () {
            var parentStore = this.context.parentStore;
            if (parentStore instanceof stores_1.ArrayStore) {
                this.fields.forEach(function (data) {
                    parentStore.registerField(data.field);
                });
            }
            else {
                if (this.fields.length === 0 || this.fields.some(function (data) { return !data.name; })) {
                    throw new Error('All fields must have names when the parent is not an ArrayField');
                }
                this.fields.forEach(function (data) {
                    parentStore.registerField(data.name, data.field);
                });
            }
        };
        class_1.prototype.componentWillUnmount = function () {
            var parentStore = this.context.parentStore;
            if (parentStore instanceof stores_1.ArrayStore) {
                this.fields.forEach(function (data) {
                    parentStore.unregisterField(data.field);
                });
            }
            else {
                if (this.fields.length === 0) {
                    throw new Error('Names are required when the parent is not an ArrayField');
                }
                this.fields.forEach(function (data) {
                    parentStore.unregisterField(data.name);
                });
            }
        };
        return class_1;
    }(superclass));
}
exports.IsRegisteredField = IsRegisteredField;
//# sourceMappingURL=isRegisteredField.js.map